#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#define FNAME "dic.txt"

typedef struct {
    char eword[500];
    char pronun[30];
    char jword1[30];
    char jword2[30];
    char jword3[30];
    char jword4[30];
    char esente1[100];
    char jsente1[400];
    char esente2[100];
    char jsente2[400];
    char esente3[100];
    char jsente3[400];
    char esente4[100];
    char jsente4[400];
} Engdata;

void rep_uscore_to_spa(Engdata *engdata) {
  int i = 0;

  while (engdata->esente1[i] != '\0') {
    if (engdata->esente1[i] == '_') {
      engdata->esente1[i] = ' ';
    } 
    i++;
  }

  i = 0;
  while (engdata->esente2[i] != '\0') {
    if (engdata->esente2[i] == '_') {
      engdata->esente2[i] = ' ';
    } 
    i++;
  }

  i = 0;
  while (engdata->esente3[i] != '\0') {
    if (engdata->esente3[i] == '_') {
      engdata->esente3[i] = ' ';
    } 
    i++;
  }

  i = 0;
  while (engdata->esente4[i] != '\0') {
    if (engdata->esente4[i] == '_') {
      engdata->esente4[i] = ' ';
    } 
    i++;
  }
}

int read_file(Engdata engdata[]) {
    FILE *fp;
    int i = 0;

    if ((fp = fopen(FNAME, "r")) == NULL) {
      perror("read_file()");
    } else {
      while (fscanf(fp, "%s%s%s%s%s%s%s%s%s%s%s%s%s%s", engdata[i].eword, engdata[i].pronun,
                    engdata[i].jword1, engdata[i].jword2, engdata[i].jword3, engdata[i].jword4,
                    engdata[i].esente1, engdata[i].jsente1, engdata[i].esente2, engdata[i].jsente2,
                    engdata[i].esente3, engdata[i].jsente3, engdata[i].esente4, engdata[i].jsente4) == 14) {
        rep_uscore_to_spa(&engdata[i]);
        i++;
      }
    }
    return i;
}

int print_struct(Engdata engdata[], int n) {
    int i;

    for (i = 0; i < n; i++) {
        printf("engdata[%4d].eword  = %s\n",  i, engdata[i].eword);
        printf("engdata[%4d].pronun = %s\n",  i, engdata[i].pronun);
        printf("engdata[%4d].jword1 = %s\n",  i, engdata[i].jword1);
        printf("engdata[%4d].jword2 = %s\n",  i, engdata[i].jword2);
        printf("negdata[%4d].jword3 = %s\n",  i, engdata[i].jword3);
        printf("engdata[%4d].jword4 = %s\n",  i, engdata[i].jword4);
        printf("engdata[%4d].esente1 = %s\n", i, engdata[i].esente1);
        printf("engdata[%4d].jsente1 = %s\n", i, engdata[i].jsente1);
        printf("engdata[%4d].esente2 = %s\n", i, engdata[i].esente2);
        printf("engdata[%4d].jsente2 = %s\n", i, engdata[i].jsente2);
        printf("engdata[%4d].esente3 = %s\n", i, engdata[i].esente3);
        printf("engdata[%4d].jsente3 = %s\n", i, engdata[i].jsente3);
        printf("engdata[%4d].esente4 = %s\n", i, engdata[i].esente4);
        printf("engdata[%4d].jsente4 = %s\n", i, engdata[i].jsente4);
    }
    
    return 0;
}

void read_mode(Engdata engdata[], int n) {
  int i;
  char buff[32];

  for (i = 0; i < n; i++) {
    printf("%s %s", engdata[i].eword, engdata[i].pronun);
    fgets(buff, sizeof(buff), stdin);
    printf("%s %s %s %s",
           engdata[i].jword1, engdata[i].jword2, engdata[i].jword3, engdata[i].jword4);
    fgets(buff, sizeof(buff), stdin);
    printf("%s %s\n%s %s\n%s %s\n%s %s\n",
           engdata[i].esente1, engdata[i].jsente1, engdata[i].esente2, engdata[i].jsente2,
           engdata[i].esente3, engdata[i].jsente3, engdata[i].esente4, engdata[i].jsente4);
    fgets(buff, sizeof(buff), stdin);
  }
}

void swap_struct(Engdata *engdata1, Engdata *engdata2) {
  Engdata tmp = *engdata1;
  *engdata1 = *engdata2;
  *engdata2 = tmp;
}

void ascend_struct(Engdata engdata[], int n) {
  int i, j;

  printf("ascend_struct(): n = %d\n", n);

  for (i = 0; i < n - 1; i++) {
    for (j = n - 1; j > i; j--) {
      int result = strcmp(engdata[j - 1].eword, engdata[j].eword);
      printf("ascend_struct(): result = %d\n", result);
      if (result > 0) {
        swap_struct(&engdata[j - 1], &engdata[j]);
      }
    }
  }
}

void randomize_struct(Engdata engdata[], int n) {
  int i;
  int rnd;

  srand(time(NULL));  // set seed

  for (i = 0; i < n; i++) {
    swap_struct(&engdata[i], &engdata[rand() % n]);
  }
}

void descend_struct(Engdata engdata[], int n){
  int i, j;

  for (i = 0; i < n - 1; i++) {
    for (j = n - 1; j > i; j--) {
      int result = strcmp(engdata[j - 1].eword, engdata[j].eword);
      if (result < 0) {
        swap_struct(&engdata[j - 1], &engdata[j]);
      }
    }
  }
}

int main(void){
    Engdata engdata[300];
    int mode;
    int dnum = 0;

    // Read file
    dnum = read_file(engdata);

    // Debug
    //printf("dnum = %d\n", dnum);
    //print_struct(engdata, dnum);

    // Select game mode
    printf("Select Mode\n"
            "0: Read Mode (registration order)\n"
            "1: Read Mode (ascending order)\n"
            "2: Read Mode (descending order)\n"
            "3: Read_Mode (random order)\n"
            "Mode: ");
    scanf("%d%*c", &mode);
    putchar('\n');

    // Switch mode
    switch (mode) {
    case 0:
      read_mode(engdata, dnum);
      break;
    case 1:
      ascend_struct(engdata, dnum);
      read_mode(engdata, dnum);
      break;
    case 2:
      descend_struct(engdata, dnum);
      read_mode(engdata, dnum);
      break;
    case 3:
      puts("case 3");
      randomize_struct(engdata, dnum);
      read_mode(engdata, dnum);
      break;
    default:
      break;
    }

    return 0;
}
